angular.module('application.controllers')
.controller('AddressDetailCtrl', function($rootScope, $scope, $state, $ionicPopup, $ionicHistory, $localStorage, Errors, Helper, Addresses) {
	$scope.countries = $localStorage.getObject('countries');
	$scope.states = $localStorage.getObject('states');

	$scope.validate = function() {
		//Client Validation
		if($scope.data.id_country != 10)//Dni only for Italy
			$scope.data.dni = null;

		if(!$scope.data.alias) {
			Helper.genericError('addresses_INSERT_ALIAS');
		}
		else if(!$scope.data.firstname) {
			Helper.genericError('addresses_INSERT_FIRSTNAME');
		}
		else if(!$scope.data.lastname) {
			Helper.genericError('addresses_INSERT_LASTNAME');
		}
		else if(!$scope.data.address1) {
			Helper.genericError('addresses_INSERT_ADDRESS');
		}
		else if(!$scope.data.civic1) {
			Helper.genericError('addresses_INSERT_CIVIC');
		}
		else if(!$scope.data.id_country) {
			Helper.genericError('addresses_INSERT_COUNTRY');
		}
		else if(!$scope.data.city) {
			Helper.genericError('addresses_INSERT_CITY');
		}
		else if($scope.data.id_country == 10 && !$scope.data.id_state) {
			Helper.genericError('addresses_INSERT_STATE');
		}
		else if(!$scope.data.phone && !$scope.data.phone_mobile) {
			Helper.genericError('addresses_INSERT_PHONE');
		}
		else if($scope.data.dni && $scope.data.dni.length != 16) {
			Helper.genericError('addresses_DNI_LENGTH');
		}
		else if(!$scope.data.dni && $scope.data.id_country == 10) {//Only Italy
			Helper.genericError('addresses_DNI_ITALY');
		}
		else if($scope.data.postcode && (isNaN($scope.data.postcode) || $scope.data.postcode.length != 5)) {
			Helper.genericError('addresses_POSTCODE_LENGTH');
		}
		else {
			return true;
		}
	}

	if($state.params.id_address) {
		$scope.submitButtonLabel = Helper.translate('address_SUBMIT_UPDATE_BUTTON_LABEL');
		$scope.data = _.where(Addresses.stored(), {id:parseInt($state.params.id_address)})[0];
		$scope.titleView = $scope.data.alias;

		$scope.addMod = function() {
			if($scope.validate() == true) {
				Helper.loaderShow();
				Addresses.mod($scope.data)
				.then(
					function(data) {
						Helper.showAlertMessage(Helper.translate('address_UPDATE_ADDRESS_ALERT_TITLE'), Helper.translate('address_UPDATE_ADDRESS_ALERT_BODY'));
						$ionicHistory.goBack();
					},
					function(error) {
						if(error.data.errors.length) {
							if(error.data.errors[0].code == 41) {
								Helper.genericError('generic_REQUIRED_FIELDS');
							}
							else {
								Helper.genericError(error);
							}
						}
					}
				)
				.finally(
					function() {
						Helper.loaderHide();
					}
				);
			}
		}
	}
	else {
		$scope.submitButtonLabel = Helper.translate('address_SUBMIT_ADD_BUTTON_LABEL');
		$scope.titleView = Helper.translate('address_TITLE_NEW_ADDRESS');
		$scope.data = {};
		$scope.addMod = function() {
			if($scope.validate() == true) {
				Addresses.add($scope.data)
				.then(
					function(data) {
						Helper.showAlertMessage(Helper.translate('address_ADD_ADDRESS_ALERT_TITLE'), Helper.translate('address_ADD_ADDRESS_ALERT_BODY'));				
						$ionicHistory.goBack();
					},
					function(error) {
						if(error.data.errors.length) {
							if(error.data.errors[0].code == 41) {
								Helper.genericError('generic_REQUIRED_FIELDS');
							}
							else {
								Helper.genericError(error);
							}
						}
					}
				)
				.finally(
					function() {
						Helper.loaderHide();
					}
				);
			}
		}
	}
})