angular.module('application.controllers')
.controller('AddressesCtrl', function($rootScope, $scope, $state, $ionicPopup, $ionicHistory, $localStorage, Errors, Helper, Addresses) {
	$scope.doRefresh = function() {
		$scope.init(true);
	};

	$scope.del = function(id) {
		Addresses.del(id)
		.then(
			function(data) {
				Helper.toast('address_DELETED_ADDRESS');
			},
			function(error) {
				Helper.genericError(error);
			}
		)
		.finally(
			function() {
				Helper.loaderHide();
			}
		);
	}

	$scope.init = function(refresh) {
		if(!refresh)
			Helper.loaderShow();

		Addresses.list()
		.then(
			function(data) {
				$scope.addresses = _.map(data, function(item) {
					item.country = _.where($localStorage.getObject('countries'), {id:parseInt(item.id_country)})[0];
					item.state = _.where($localStorage.getObject('states'), {id:parseInt(item.id_state)})[0];
					return item;
				});
			},
			function(error) {
				Helper.genericError(error);
			}
		)
		.finally(
			function() {
				if(refresh)
	   				$scope.$broadcast('scroll.refreshComplete');
	   			else
					Helper.loaderHide();
			}
		);
	}

	$scope.init();
})