angular.module('application.controllers')
.controller('CategoriesCtrl', function($scope, Categories) {
	$scope.doRefresh = function() {
		$scope.init(true);
	}

	$scope.init = function(refresh) {
		if(refresh) {
			Categories.list()
			.then(
				function(data) {
					$scope.categories = _.where(data, {id_parent:AppSettings.rootCategoryId});
					$scope.categories = _.sortBy($scope.categories, function(item) { return parseInt(item.position); });
				}
			)
			.finally(
				function() { 
				   	$scope.$broadcast('scroll.refreshComplete');
			   	}
		   	);
		}
		else {
			//Use cached data
			$scope.categories = _.where(Categories.stored(), {id_parent:AppSettings.rootCategoryId});// Home Page ID
			$scope.categories = _.sortBy($scope.categories, function(item) { return parseInt(item.position); });
		}
	}

	$scope.init(true);
})