angular.module('application.controllers')
.controller('HomeCtrl', function($rootScope, $scope, $state, $ionicPopup, $ionicSlideBoxDelegate, $location, Helper, Categories, News) {
	$scope.doRefresh = function() {
		$scope.init(true);
	}

	$scope.goToNews = function(id) {
		$state.go('app.newsdetail', {id_news:id});
	}

	$scope.subcategories = function(category) {		
		var result = _.where($scope.allCategories, {id_parent: category.id.toString()});
		result = _.sortBy(result, function(item) { return parseInt(item.position); });

		return result;
	}

	$scope.toggleSideMenu = function(category) {
		$scope.openCategory = $scope.isOpen(category) ? null : category;
	}

	$scope.isOpen = function(category) {
		return (category == $scope.openCategory);
	}

	$scope.go = function (path) {
		$location.path(path);
	}

	$scope.init = function(refresh) {
		$scope.imagesBaseUrlCategories = AppSettings.imagesBaseUrlCategories;
		$scope.device = $rootScope.device;

		$scope.openCategory = null;

		if(refresh) {
			Categories.list()
			.then(
				function(data) {
					$scope.allCategories = _.sortBy(data, function(item) { return parseInt(item.position); });

					$scope.categories = _.where(Categories.stored(), {id_parent:AppSettings.rootCategoryId});
					$scope.categories = _.sortBy($scope.categories, function(item) { return parseInt(item.position); });
					$rootScope.categories = $scope.categories;//Refresh categories in tablet menu
					$scope.initNews();
				}
			)
			.finally(
				function() {
				   	$scope.$broadcast('scroll.refreshComplete');
				}
			);
		}
		else {
			//Use cached data
			$scope.categories = _.where(Categories.stored(), {id_parent:AppSettings.rootCategoryId});
			$scope.categories = _.sortBy($scope.categories, function(item) { return parseInt(item.position); });

			$scope.allCategories = Categories.stored();
			$scope.allCategories = _.sortBy($scope.allCategories, function(item) { return parseInt(item.position); });
		}
	}

	$scope.initNews = function() {
		Helper.loaderShow();
		$scope.news = [];
		News.list()
		.then(
			function(data) {
				if(data.length) {
					$scope.news = _.map(data, function(item) {
						if(item.image)
							item.image = item.image.replace("/list/", "/");
						return item;
					});
				}
			}
		)
		.finally(
			function() {
				Helper.loaderHide();
			   	$ionicSlideBoxDelegate.update();
			}
		);
	}
})

