angular.module('application.controllers')
.controller('LoginCtrl', function($rootScope, $scope, $state, $window, $ionicPopup, $ionicHistory, $cordovaFacebook, Helper, Errors, Customers, Carts) {
	$scope.data = {};

	if(AppSettings.debug) {
		$scope.data = {
			email: AppSettings.userEmailDemo,
			passwd: AppSettings.userPasswordDemo
		};
	}

	$scope.loginFb = function() {
		$window.async.waterfall([
			function(callback) {
				$cordovaFacebook.getLoginStatus()
				.then(
					function(data) {
						callback(null, data);
					},
					function(error) {
						callback(error);
					}
				)
		    },
		    function(result, callback) {
		    	if(result.status == 'connected') {
		    		$cordovaFacebook.logout()
		    		.then(
						function(data) {
							callback(null);
						},
						function(error) {
							callback(error);
						}
	    			)
		    	}
		    	else {
		    		callback(null);
		    	}
	    	},
		    function(callback) {
		    	$cordovaFacebook.login(["public_profile", "email"/*, "user_birthday"*/])
			    .then(
			    	function(data) {
				    	callback(null);
				    }, 
				    function (error) {
				      	callback(error);
				    }
			    );
		    },
		    function(callback) {//,birthday,location
		    	$cordovaFacebook.api("me/?fields=id,email,first_name,last_name,gender", ["public_profile", "email"/*, "user_birthday"*/])
		    	.then(
				  	function(result) {
				  		callback(null, result);
			    	},
			    	function(error) {
			    		callback(error);
			  		}
		  		);
		    },
		    function(result, callback) {
		    	//Signup or login user with Facebook in Prestashop
				Helper.loaderShow();

		    	var params = {
		    		fbId: result.id,
		    		firstname: result.first_name,
		    		lastname: result.last_name,
		    		email: result.email,
		    		passwd: Math.random().toString(36),
		    		id_lang: $rootScope.lang.id,
		    		id_shop: AppSettings.id_shop,
		    		id_shop_group: AppSettings.id_shop_group,
		    		id_default_group: AppSettings.id_default_group,
		    		id_risk: 0,
		    		birthday: result.birthday ? moment(result.birthday, ['MM/DD/YYYY']).format("YYYY-MM-DD") : null,
		    		active: 1,
		    		id_gender: result.gender == 'male' ? 1 : 2
	    		}

	    		Helper.log(params);

	    		Customers.loginFb(params)
	    		.then(
	    			function(data) {
	    				callback(null, data);
	    			},
	    			function(error) {
	    				callback(error);
	    			}
    			)
		    },
		    function(result, callback) {
				Customers.get(result.id_customer)
				.then(
					function(data) {
						if(data && data.length) {
							Customers.setSession(data[0]);
							Helper.log("User logged by Facebook!");

							Carts.last(true);

							Helper.goBack();
							Helper.toast('login_WELCOME');
						}
						else {
							Helper.genericError('login_ERROR_ACCESS');
						}
						Helper.loaderHide();
					},
					function(error) {
						if(error) {
							Helper.log(JSON.stringify(error));
							Helper.genericError(Helper.translate('login_FB_ERROR'));
						}
						Helper.loaderHide();
					}
				);
		    }
	    ])
    };

	$scope.login = function() {
		if(!$scope.data.email || !$scope.data.passwd) {
			Helper.genericError('login_ERROR_ACCESS_INSERT_DATA');
		}
		else {
			var params = JSON.parse(JSON.stringify($scope.data));

			Helper.loaderShow();
			Customers.login(params)
			.then(
				function(data) {
					if(data && data.active) {
						Customers.setSession(data);
						Helper.log("User logged!");

						Helper.goBack();
						Helper.toast('login_WELCOME');
					}
					else {
						Helper.genericError('login_ERROR_ACCESS');
					}
				},
				function(error) {
					Helper.genericError('login_ERROR_ACCESS');
				}
			)
			.finally(
				function() {
					Helper.loaderHide();
				}
			);
		}
	}

	$scope.resetPassword = function() {
		if(!$scope.data.email) {
			Helper.genericError('resetpassword_ERROR_NO_EMAIL');
		}
		else {
			Helper.loaderShow();
			Customers.resetPassword({email:$scope.data.email})
			.then(
				function(data) {
					Helper.showAlertMessage(Helper.translate('login_RESET_PASSWORD_SUCCESS_TITLE'), Helper.translate('login_RESET_PASSWORD_SUCCESS_BODY'));
					$state.go('app.login');
				},
				function(error) {
					if(error.data.email) {
						Helper.genericError('resetpassword_ERROR_ADDRESS');
					}
				}
			)
			.finally(
				function() {
					Helper.loaderHide();
				}
			);
		}
	}
})