angular.module('application.controllers')
.controller('NewsCtrl', function($rootScope, $scope, $ionicPopup, $window, $localStorage, News, Helper) {
	$scope.doRefresh = function() {
		$scope.init();
	   	$scope.$broadcast('scroll.refreshComplete');
	}

	$scope.init = function() {
		Helper.loaderShow();

		$scope.news = [];

		News.list()
		.then(
			function(data) {
				if(data) {
					var news = _.map(data, function(item) {
						if(item.image)
							item.image = item.image.replace("/list/", "/");
						return item;
					});
					angular.forEach(news, function(item) {
						item.pubDate = moment(item.pubDate, ['DD/MM/YYYY', 'YYYY/MM/DD']).format("DD-MM-YYYY");
						$scope.news.push(item);
					});
				}
			},
			function(error) {
				Helper.genericError(error);
			}
		)
		.finally(
			function() {
				Helper.loaderHide();
			}
		);
	}

	$scope.init();
})