angular.module('application.controllers')
.controller('OrderDetailCtrl', function($scope, $state, Helper, RestService) {
	$scope.formatData = function() {
		$scope.order.date_add = moment($scope.order.date_add, ['DD/MM/YYYY', 'YYYY/MM/DD']).format("ll");

		if($scope.order.store) {
			$scope.order.store.date_pickup = moment($scope.order.store.date_pickup, ['DD/MM/YYYY', 'YYYY/MM/DD']).format("ll");
		}
		
		$scope.articles_quantity = _.reduce($scope.order.products, function(sum, item) {
			return sum + parseInt(item.product_quantity);
		}, 0);
	}

	$scope.configOrder = function() {
		$scope.formatData();
		Helper.loaderHide();
	}

	$scope.init = function() {
		$scope.orderData();
	}

	$scope.orderData = function() {
		Helper.loaderShow();
		RestService.request('custom', {action: 'order_detail', id: $state.params.id_order}, 'GET')
		.then(
			function(data) {
				Helper.log(data);
				$scope.order = data;
				$scope.configOrder();
			},
			function(error) {
				Helper.genericError('order_ERROR_DETAIL_DATA');
			}
		)
		.finally(
			function() {
				Helper.loaderHide();

   				$scope.$broadcast('scroll.refreshComplete');
			}
		)
	}

	$scope.init();
})