angular.module('application.controllers')
.controller('OrdersCtrl', function($scope, $state, $ionicPopup, $localStorage, Helper, Orders) {
	$scope.doRefresh = function() {
		$scope.init();
	   	$scope.$broadcast('scroll.refreshComplete');
	}

	$scope.init = function() {
		Helper.loaderShow();
		Orders.list()
		.then(
			function(data) {
				var order_states = $localStorage.getObject('order_states');
				$scope.orders = _.map(data, function(item) {
					item.date_add = moment(item.date_add, ['DD/MM/YYYY', 'YYYY/MM/DD']).format("ll");
					item.state = _.where(order_states, {id:parseInt(item.current_state)})[0];
					item.price_payment_tax_incl = 0;

					item.total_products_wt = Helper.applyTax(item.total_products);
					return item;
				});
			},
			function(error) {
				Helper.log(JSON.stringify(error));
			}
		)
		.finally(
			function() {
				Helper.loaderHide();
			}
		);
	}

	$scope.init();
})