angular.module('application.controllers')
.controller('ProductDetailCtrl', function(
	$rootScope, 
	$scope, 
	$sce,
	$ionicPopup, 
	$state, 
	$window, 
	$filter, 
	$timeout, 
	$cordovaInAppBrowser, 
	$ionicSlideBoxDelegate,
	$ionicModal, 
	$ionicScrollDelegate, 
	$localStorage, 
	Helper, 
	Categories, 
	Products, 
	Combinations, 
	Customers, 
	Orders, 
	Carts, 
	Social, 
	Customers,
	RestService,
	Addresses
) {
	$scope.changeSlide = function(index) {
		$ionicSlideBoxDelegate.slide(index, 500);
	}

	$scope.toggleDescription = function() {
	    $scope.shownDescription = !$scope.shownDescription;
	    $timeout(function() {
	    	$scope.$broadcast('scroll.resize');
	    	$ionicScrollDelegate.scrollBottom(true);
	    }, 100);
	};

	$scope.socialShare = function(social) {
		Social.share(social, 'product', $scope.siteUrl, $scope.product);
	};

	$scope.sizeGuideOpen = function() {
		$scope.imgSizeGuide = AppSettings.siteUrl + '/img/sizeguide.png';
	    $ionicModal.fromTemplateUrl('size-guide.html', {
		    scope: $scope,
		    animation: 'slide-in-up',
		}).then(function(modal) {
			$scope.modal = modal;
			$scope.modal.show();
		});
	};

	$scope.sizeGuideClose = function() {
		$scope.modal.hide();
	};

	$scope.loaderShow = function() {
		Helper.loaderShow();
	};

	$scope.crl = false;
	$scope.loaderHide = function() {
		$timeout(function() {
			circlr('circlr', {
			  	autoplay : true,
			  	playSpeed: 600,
			});
			$scope.crl = true;
			Helper.loaderHide();
		}, 100);
	};

	$scope.loadMagic360 = function() {
		Products.model3d($state.params.id_product)
		.then(
			function(data) {
				$scope.model3d = data;
			},
			function(error) {
				console.log(error);
			}
		);
	}

	$scope.magic360Open = function() {
	    $ionicModal.fromTemplateUrl('magic360.html', {
		    scope: $scope,
		    animation: 'slide-in-up',
		    backdropClickToClose: false,
		    hardwareBackButtonClose: false,
		}).then(function(modal) {
			$scope.modal360 = modal;
			$scope.modal360.show();
		});
	};

	$scope.magic360Close = function() {
		$scope.modal360.hide();
		$timeout(function() {
			$scope.modal360.remove();
		}, 300);
	};

	$scope.refreshCart = function(data) {
		$scope.cart = data;
		$scope.cart.products = _.map($scope.cart.products, function(item) {
			item.qtRange = _.range(1, item.quantity_available);
			item.imageUrl = AppSettings.imagesBaseUrl + item.id_image.replace('-','/') + '-medium_default.jpg';
			return item;
		});
		Carts.setCart($scope.cart);
	}

	$scope.addToCart = function() {
		if(!$scope.combination) {
			Helper.genericError('products_CHOOSE_ATTRIBUTES');
		}
		else {
			Helper.loaderShow();
			//Change combination quantity in the cart
			RestService.request('custom', {
				action: 'change_quantity', 
				id_customer: Customers.getSession() ? Customers.getSession().id : 0,
				secure_key: Helper.secureKey(),
				id_cart: $scope.cart ? $scope.cart.id : 0,
				id_product: $scope.combination.id_product,
				id_product_attribute: $scope.combination.id,
				add: 1,
			}, 'GET')
			.then(
				function(data) {
					var combProduct = _.where(data.products, {id_product_attribute:$scope.combination.id.toString()})[0];
					$scope.quantity = combProduct.quantity_available - combProduct.quantity;
	    			$scope.refreshCart(data);
				},
				function(error) {
					callback(error);
				}
			)
			.finally(
				function() {
					Helper.loaderHide();
				}
			);
		}
	};

	$scope.filterOpened = false;

	$scope.openFilter = function(option_group_id) {
		if ($scope.filterOpened) {
			$scope.closeFilter(option_group_id, true);
		} else {
			move('#option_group_' + option_group_id)
				.set("opacity", 1)
				.set("z-index", 3)
				.set("bottom", '3rem')
				.duration('.6s')
				.ease('in-out')
			  	.end();

		  	$scope.filterOpened = true;
	  	}
	};

	$scope.closeFilter = function(option_group_id, onlyAnimation) {
		move('#option_group_' + option_group_id)
			.set("bottom", '-3rem')
			.set("opacity", 0)
			.set("z-index", 0)
			.duration('.0s')
			.ease('in-out')
		  	.end();

  		$scope.option_selected[option_group_id] = $scope.getOptionValue($scope.filter_options[option_group_id]);
  		$scope.$broadcast('scroll.resize');
		$scope.filterOpened = false;

  		if (!onlyAnimation) {
			$scope.findCombination();
		}
	};

	$scope.getOptionValue = function(id_option) {
	  	return _.where($localStorage.getObject('product_option_values'), {id:id_option})[0];
	}

	// Video Youtube START /////////////////////////////////////////////////////
	$scope.players = [];
	$scope.activeVideo = null;
	
	$scope.trustSrc = function(src) {
	    return $sce.trustAsResourceUrl(src);
	}

	$scope.getThumb = function(id) {
		return $sce.trustAsResourceUrl('https://img.youtube.com/vi/' + id + '/mqdefault.jpg');
	}

	$scope.toggleVideo = function(id) {
		if($scope.activeVideo == id) {
			$scope.stopVideo();
		} else {
			$scope.onYouTubeIframeAPIReady(id);
	  		$scope.activeVideo = id;
  		}
	}

  	$scope.onYouTubeIframeAPIReady = function(id) {
		$scope.stopVideo();
  		if($scope.players[id]) {
  			$scope.player = $scope.players[id];
  			$scope.player.playVideo();
	    }
	    else {
		    $scope.player = new YT.Player('player_' + id, {
		      	height: '100%',
		      	width: '100%',
		      	videoId: id,
		      	playerVars: {
			        controls: 2,
			        autohide: 1,
			        autoplay: 0,
			        showinfo: 0,
			        fs: 0,
			        rel: 0,
			        playsinline: 1,
			        theme: 'light',
		        },
		      	events: {
		        	'onReady': $scope.onPlayerReady,
		      	}
		    });
		    $scope.players[id] = $scope.player;
		    //Play when ready
	    }
  	}

	$scope.onPlayerReady = function(event) {
		event.target.playVideo();
	}

	$scope.stopVideo = function() {
		if($scope.player) {
			$scope.activeVideo = null;
			$scope.player.stopVideo();
		}
	}
	// Video Youtube END /////////////////////////////////////////////////////

	$scope.findCombination = function() {
		//Selected attributes
	  	var attributes_values = _.map($scope.filter_options, function(value) {
	  		return value;
	  	}).sort();

	  	//All the combination of this product
	  	var combinations = Combinations.stored();
	  	$scope.quantity = 0;

	  	var result = _.map(combinations, function(item) {
	  		var attributes = JSON.stringify(_.map(item.associations.product_option_values, function(item2) {
	  			return parseInt(item2.id);
	  		}).sort());

	  		return {id: item.id, attributes: attributes};
	  	});

	  	var combination = _.where(result, {attributes:JSON.stringify(attributes_values)});
	  	if(combination.length) {
	  		$scope.combination = _.where(combinations, {id:combination[0].id})[0];
	  		$scope.product.price = Helper.applyTax($scope.combination.price) + parseFloat($scope.product.basePrice);
	  		$scope.slider = $scope.combination.associations.images;

	  		if(!$scope.slider) {
				$scope.slider = $scope.product.associations.images;	  			
	  		}

	  		//For not logged users
			var params = {
				id_product: parseInt($scope.product.id),
				id_shop: AppSettings.id_shop,
				id_currency: AppSettings.id_currency,
				id_group: AppSettings.id_default_group,
				id_product_attribute: $scope.combination.id
			};

			if(Customers.getSession()) {
				params = {
					id_product: parseInt($scope.product.id),
					id_shop: parseInt(Customers.getSession().id_shop),
					id_currency: parseInt(AppSettings.id_currency),
					id_country: Addresses.stored() ? parseInt(Addresses.stored()[0].id_country) : 0,
					id_group: parseInt(Customers.getSession().id_default_group),
					id_customer: parseInt(Customers.getSession().id),
					id_product_attribute: $scope.combination.id
				};
			}

			//Specific price
			Products.verifyReduction(params)
			.then(
				function(reduction) {
					if(parseFloat(reduction.reduction) > 0) {
						$scope.product.price_no_reduction = $scope.product.price;
						if(reduction.reduction_type == 'percentage') {
							$scope.product.price = $scope.product.price_no_reduction * (1 - parseFloat(reduction.reduction));
						}
						else if(reduction.reduction_type == 'amount') {
							$scope.product.price = $scope.product.price_no_reduction - parseFloat(reduction.reduction);
						}
					}
					else {
						$scope.product.price_no_reduction = null;
					}
				},
				function(error) {
					callback(null);
				}
			)

	  		Combinations.stockAvailable($scope.combination.id)
	    	.then(
	    		function(dataComb) {
	    			if(Carts.lastCart && Carts.lastCart.associations) {
		    			var cartRows = Carts.lastCart.associations.cart_rows ? Carts.lastCart.associations.cart_rows.cart_row : null;

		    			var isCombInCart = _.where(cartRows, {id_product_attribute:$scope.combination.id.toString()});
		    			var quantityInCart = isCombInCart.length ? parseInt(isCombInCart[0].quantity) : 0;
		    			var quantityCombination = dataComb.length ? parseInt(dataComb[0].quantity) : 0;
		    			$scope.combination.quantity = quantityCombination - quantityInCart;
	    			}
	    			else {
	    				var quantityCombination = dataComb.length ? parseInt(dataComb[0].quantity) : 0;
		    			$scope.combination.quantity = quantityCombination;
	    			}
	    			$scope.quantity = $scope.combination.quantity;
	    		},
				function(error) {
					
				}
    		)

	  		//Fix ion-content scroll after slider update
	  		$scope.sliderPosition = 'absolute';
	  		$timeout(function() {
	  			$scope.sliderPosition = 'relative';
	  		});
	  		$ionicSlideBoxDelegate.slide(0, 100);
  			$ionicSlideBoxDelegate.update();
  			$scope.$broadcast('scroll.resize');
	  	}
	  	else {
	  		$scope.combination = null;
	  		Helper.log("Non esiste una combinazione per questo prodotto con gli attributi selezionati");
	  	}
	};

	//Init
	$scope.langCode = $rootScope.lang.iso_code;
	$scope.category = _.where(Categories.stored(), {id:parseInt($state.params.id_category)})[0];
	$scope.imagesBaseUrlAttributes = AppSettings.imagesBaseUrlAttributes;
	$scope.imagesBaseUrl360 = AppSettings.baseUrl + '/img/magic360';
	$scope.shownDescription = false;

	//Product detail init
	Helper.loaderShow();
	$window.async.series({
	    product: function(callback) {
	    	Products.get($state.params.id_product)
			.then(
				function(data) {
					$localStorage.setObject('lastProductId', $state.params.id_product); 
					if(data.products) {
						callback(null, data.products[0]);
					}
				},
				function(error) {
					callback(error);
				}
			);
	    },
	    quantity: function(callback) {
	    	Products.stockAvailable($state.params.id_product)
	    	.then(
	    		function(data) {
	    			var quantity = data.length ? parseInt(data[0].quantity) : 0;
					callback(null, quantity);
	    		},
				function(error) {
					callback(error);
				}
    		)
	    },
	    product_videos: function(callback) {
	    	Products.videos($state.params.id_product)
	    	.then(
	    		function(data) {
	    			$scope.videos = data;
					callback(null, data);
	    		},
				function(error) {
					callback(error);
				}
    		)
	    },
	    combinations: function(callback) {
	    	Combinations.list($state.params.id_product)
	    	.then(
				function(data) {
					callback(null, data);
				},
				function(error) {
					callback(error);
				}
			);
	    }
	},
	function(err, results) {
		Helper.loaderHide();
		if(err) {
			Helper.genericError(err);
		}
		else if(results) {
			$scope.product = results.product;
			$scope.product.basePrice = Helper.applyTax($scope.product.price);

			$scope.product.title = $scope.product.name;
			$scope.product.image = $scope.imagesBaseUrl + $scope.product.id + "/" + $scope.product.associations.images[0].id + "-home_default.jpg";
			$scope.slider = $scope.product.associations.images;

			//Available options to searching combinations
			$scope.product_options = _.map($scope.product.associations.product_option_values, function(item) {
				var result = _.where($localStorage.getObject('product_option_values'), {id:parseInt(item.id)});
				if(result.length > 0)
					return result[0];
			});
			$scope.product_options = _.sortBy($scope.product_options, function(item) {
				if(item)
					return parseInt(item.position);
			});

			var options = $localStorage.getObject('product_options');
			$scope.product_options = _.groupBy($scope.product_options, 'id_attribute_group', false);
			$scope.product_options = _.map($scope.product_options, function(item, key) {
				var result = _.where($localStorage.getObject('product_options'), {id:parseInt(key)});
				if(result && result.length) {
					result[0].values = item;
					return result[0];
				}
			});
			$scope.product.quantity = results.quantity;
			$scope.quantity = results.quantity;
			$scope.product.associations.combinations = results.combinations;

			if($rootScope.filter_options && $rootScope.option_selected && $rootScope.filter_options.length && $rootScope.option_selected.length) {
				$scope.filter_options = $rootScope.filter_options;
				$scope.option_selected = $rootScope.option_selected;
			}
			else {
				$scope.filter_options = {};
				$scope.option_selected = [];

				//Select default combination
				var defaultComb = _.where(results.combinations, {default_on:"1"});
				if(defaultComb.length) {
					defaultComb = defaultComb[0];

					angular.forEach(defaultComb.associations.product_option_values, function(item) {
						var attr = $scope.getOptionValue(parseInt(item.id));
						$scope.option_selected[attr.id_attribute_group] = attr;
						$scope.filter_options[attr.id_attribute_group] = parseInt(item.id);
					});
					$rootScope.filter_options = $scope.filter_options;
					$rootScope.option_selected = $scope.option_selected;
				}
			}
			$scope.findCombination();
			$scope.loadMagic360();
		}
	});
})