angular.module('application.controllers')
.controller('ProductsCtrl', function(
	$scope, 
	$state, 
	$ionicScrollDelegate, 
	$localStorage,
	$location,
	Helper, 
	Categories, 
	RestService
) {
	$scope.doRefresh = function() {
		$scope.init();
	   	$scope.$broadcast('scroll.refreshComplete');
	   	$scope.$apply();
	}

	$scope.init = function() {
		$scope.category = _.where(Categories.stored(), {id:parseInt($state.params.id_category)})[0];
		$scope.parentCategory = _.where(Categories.stored(), {id:parseInt($scope.category.id_parent)})[0];

		Helper.loaderShow();
		RestService.request('custom', {action: "products_category", id_category: $scope.category.id}, 'GET')
		.then(
			function(data) {
				$scope.products = _.map(data, function(item) {
					item.imageUrl = AppSettings.imagesBaseUrl + item.id_image.replace('-','/') + '-home_default.jpg';
					return item;
				});

				var lastProductId = $localStorage.getObject('lastProductId');
				if(lastProductId) {
					$location.hash("product-" + lastProductId);
           			$ionicScrollDelegate.anchorScroll(false);
				}
			},
			function(error) {
				
			}
		)
		.finally(
			function() {
				Helper.loaderHide();
			}
		)
	}

	$scope.init();
});