angular.module('application.controllers')
.controller('ProfileCtrl', function($rootScope, $scope, $state, $ionicPopup, $ionicHistory, Errors, Helper, Customers) {
	$scope.getData = function() {
		var data = Customers.getSession();

		data.passwd = '';
		data.birthday = moment(data.birthday).isValid() ? moment(data.birthday, ['DD/MM/YYYY', 'YYYY/MM/DD'])._d : null;
		$scope.data = data;
	}

	$scope.updatePassword = function() {
		var params = JSON.parse(JSON.stringify($scope.data));

		params.birthday = moment(params.birthday).isValid() ? moment(params.birthday, ['DD/MM/YYYY', 'YYYY/MM/DD']).format("YYYY-MM-DD") : null;
		params.date_add = null;
		params.date_upd = null;

		if(!params.passwd) {
			Helper.genericError('login_ERROR_NO_PASSWORDS');
		}
		else if(params.passwd.length < 8) {
			Helper.genericError('login_ERROR_LENGTH_PASSWORDS');
		}
		else if(params.passwd != params.passwd_repeat) {
			Helper.genericError('login_ERROR_PASSWORDS');
		}
		else {
			Helper.loaderShow();
			Customers.mod(params)
			.then(
				function(data) {
					if(data.customer) {
						Customers.setSession(data.customer);
						Helper.log("Password updated");
						Helper.showAlertMessage(Helper.translate('profile_UPDATE_PASSWORD_ALERT_TITLE'), Helper.translate('profile_UPDATE_PASSWORD_ALERT_BODY'));
						
						$ionicHistory.goBack();
					}
				},
				function(error) {
					if(parseInt(error.data.errors[0].code) == 97 || parseInt(error.data.errors[0].code) == 46) {
						Helper.genericError('signup_ERROR_DUPLICATE');
					}
					else {
						Helper.genericError(error);
					}
				}
			)
			.finally(
				function() {
					Helper.loaderHide();
				}
			);
		}
	}

	$scope.update = function() {
		var params = JSON.parse(JSON.stringify($scope.data));

		params.birthday = moment(params.birthday).isValid() ? moment(params.birthday, ['DD/MM/YYYY', 'YYYY/MM/DD']).format("YYYY-MM-DD") : null;
		params.date_add = null;
		params.date_upd = null;

		if((params.passwd || params.passwd_repeat) && params.passwd != params.passwd_repeat) {
			Helper.genericError('login_ERROR_PASSWORDS');
		}
		else {
			Helper.loaderShow();
			Customers.mod(params)
			.then(
				function(data) {
					if(data.customer) {
						Customers.setSession(data.customer);
						Helper.log("Password updated");
						Helper.showAlertMessage(Helper.translate('profile_UPDATE_PERSONAL_DATA_ALERT_TITLE'), Helper.translate('profile_UPDATE_PERSONAL_DATA_ALERT_BODY'));
						
						$ionicHistory.goBack();
					}
				},
				function(error) {
					if(parseInt(error.data.errors[0].code) == 97 || parseInt(error.data.errors[0].code) == 46) {
						Helper.genericError('signup_ERROR_DUPLICATE');
					}
					else {
						Helper.genericError(error);
					}
				}
			)
			.finally(
				function() {
					Helper.loaderHide();
				}
			);
		}
	}
	$scope.getData();
})