angular.module('application.controllers')
.controller('StoreDetailCtrl', function($rootScope, $scope, $state, $ionicPopup, Stores, Helper) {
	Helper.loaderShow();
	Stores.get($state.params.id_store)
		.then(
			function(data) {
				$scope.store = data.stores[0];

				var positionLatLng = new google.maps.LatLng($scope.store.latitude, $scope.store.longitude);

				if($rootScope.gpsPosition) {
	        		var d = Helper.distance($rootScope.gpsPosition.latitude, $rootScope.gpsPosition.longitude, $scope.store.latitude, $scope.store.longitude);
    				$scope.store.distance = parseFloat(d) < 1000 ? d + "m" : parseFloat(d / 1000).toFixed(2) + "Km";
				}

				var mapOptions = {
		          	center: positionLatLng,
		          	zoom: 16,
		          	mapTypeId: google.maps.MapTypeId.ROADMAP,
		          	mapTypeControl: false,
		          	zoomControl: false
		        };
		        var map = new google.maps.Map(document.getElementById("map-store"), mapOptions);

		        var marker = new google.maps.Marker({
		          	position: positionLatLng,
		          	map: map,
	          		icon: "img/map_marker.png",
		          	title: $scope.store.name
		        });
				$scope.store.times = Stores.times($scope.store.hours);
			},
			function(error) {
				Helper.genericError(error);
			}
		)
		.finally(
			function() {
				Helper.loaderHide();
			}
		);
})